
{Serial Character Stream Generator
Transmit test streams for formstted testing}
CON
        _clkmode = xtal1 + pll16x    'Standard clock mode 
        _xinfreq = 5_000_000         '* crystal frequency = 80 MHz
        Led = 27
        TxOut = 17
        BaudRate = 10560         '   
        HalfStops = 0               '1 stop bit
                      
VAR    
  long  Command                        '<> 0 says => driveer busy
                                       '14..0 :  Address in hub memory
  long  MyParm[6]                      'passing addresses, etc to display driver
  byte  Cog

DAT
MyString byte   "$GPZDA,093045", 13, 0
HexVal   byte   "ABCD", 0
DecVal   byte   "12345", 0  

OBJ
  pst      : "parallax serial terminal"
  
PUB main
    pst.Start (115_200)                  'start up ser terminal
    pst.str(String("hello, world   "))   'runs in cog 1
    pst.NewLine
    waitcnt(clkfreq/10 + cnt)

    MyParm[0] := @Command               'address of string to send
    MyParm[1] := 80_000_000/BaudRate    'bit time in clock cycles
    MyParm[2] := HalfStops              'optional extra half stop bits                      
    cog := cognew(@PCog, @MyParm)       'start up the output cog
    pst.str(String("Transmit Cog: "))             '
    pst.hex(Cog,1)
    pst.NewLine
    waitcnt(clkfreq/2+cnt)
    dira[led]~~

    repeat
      outa[led]~~
      Command := @MyString             'transmit first string
      repeat while (Command <> 0)      'wait until done
      waitcnt(clkfreq/5 + cnt)        'wait for string to be "processed"    
      
      Command := @HexVal               'transmit hex
      repeat while (Command <> 0)      
      waitcnt(clkfreq/5 + cnt)          
               
      Command := @DecVal                'transmit dec
      repeat while (Command <> 0)
      outa[led]~      
      waitcnt(clkfreq + cnt)                                             
      pst.char("*")
    
          
DAT
PCog    org   0                  'This PASM driver is a serial driver
        mov AdPar,Par            'get the address of input parameters
        rdlong AdCommand, AdPar  'address of command long
        add AdPar, #4
        rdlong BitTime, AdPar   'clocks per bit
        mov HalfBT, BitTime
        shr HalfBT, #1           'clocks per half bit time
        add AdPar, #4
        rdlong HalfSB, AdPar    'number of half stop bits
        or outa, TxMask         'comes up high   
        or dira, TxMask         'transmitter is an output
       
'*********************wait here for something to do*************************                                                   
top     rdlong AdString, AdCommand wz  'wait for a command (address of string)
        if_Z jmp #top                   'just hang here
         
Cloop   rdbyte TheChar, AdString wz     'get the (first)(next) character
        if_Z jmp #done                  'zero terminated string
        add AdString, #1                'point to following char
        mov BitCount, #8                '8 bits per character
        mov time, BitTime
        add time, cnt                   'time at end of start bit
        andn outa, TxMask               'send start bit
        waitcnt time, BitTime           'time start bit
BLoop   shr TheChar, #1 wc              'next (first) bit into carry
        muxc outa, TXMask               'then onto pin 
        waitcnt time, BitTime           'one bit time
        djnz BitCount, #BLoop           'eight bits per character
        or outa, TXMask                 'stop bit
        waitcnt time, HalfBT            'one stop bit
        mov BitCount, HalfSB wz         'optional half stop bits
        if_Z jmp #CLoop                 'no optional stop bits
SLoop   waitcnt time, HalfBT            'at least one half stop bit
        djnz BitCount, #SLoop           'however many
        jmp #CLoop                      'on to next character        
done    wrlong zero, AdCommand          'tell boss cog done
        jmp #top                        'and wait for another   
                          '                  
zero        long     0               'constants
TxMask      long 1<<TxOut            'mask corresponding to transmit pin
BitTime     res                      'clocks per bit time
AdPar       res                      'address into parameter list
AdCommand   res                      'address in hub of command long
MyCommand   res                      'my copy of the command
BitCount    res                      'number of bits per character
time        res                      'time to wait
AdString    res                      'current address in string 
theChar     res                      'the character we are transmitting
HalfSB      res                      'number of optional half stop bits
HalfBT      res                      'half bit time (for optional 1/2 stops) 
                                                                           